import re
import csv
import grok
import cPickle
import zope.xmlpickle
from cStringIO import StringIO
from xml.dom.minidom import Document, getDOMImplementation
from zope.interface import Interface
from waeup.interfaces import IWAeUPObject, IWAeUPExporter, IWAeUPXMLExporter

def readFile(f):
    """read a CSV file"""
    headers = []
    rows = []
    f = csv.reader(f)
    headers = f.next()
    for line in f:
        rows.append(line)
    return (headers, rows)

def writeFile(data):
    writer = csv.writer(open("export.csv", "wb"))
    writer.writerows(data)

class Exporter(grok.Adapter):
    """Export a WAeUP object as pickle.

    This all-purpose exporter exports attributes defined in schemata
    and contained objects (if the exported thing is a container).
    """
    grok.context(IWAeUPObject)
    grok.provides(IWAeUPExporter)

    def export(self, obj, filepath=None):
        if filepath is None:
            filelike_obj = StringIO()
        else:
            filelike_obj = open(filepath, 'wb')
        exported_obj = cPickle.dump(obj, filelike_obj)
        filelike_obj.close()
        return filelike_obj

class XMLExporter(grok.Adapter):
    """Export a WAeUP object as XML.

    This all-purpose exporter exports XML representations of pickable
    objects.
    """
    grok.context(Interface)
    grok.provides(IWAeUPXMLExporter)

    def export(self, obj, filepath=None):
        pickled_obj = cPickle.dumps(obj)
        result = zope.xmlpickle.toxml(pickled_obj)
        if filepath is None:
            filelike_obj = StringIO()
        else:
            filelike_obj = open(filepath, 'wb')
        filelike_obj.write(result)
        filelike_obj.seek(0)
        return filelike_obj
